#define FILTER_MAIN 1

/* for TEST: gcc -g -o foo imfilter.c imregions.o -lm */
#ifdef TEST
#include <stdio.h>
#include <math.h>
#define IMFILTRTN _FilterImage
#define FILTER   (impie(g,1,1,1,(double)x,(double)y,4096,4096,0,180))
#define FILTSTR "(impie(g,1,1,1,(double)x,(double)y,4096,4096,0,180))"
#define FINIT     impiei(g,1,1,1,(double)x,(double)y,4096,4096,0,180);
#define NSHAPE 1
#define NREGION 1
#include "regions.h"
#endif

/* these are global for use with special region routines */
FilterMask masks=NULL;		/* array valid region masks for one row */
int maxmask;			/* max masks allocated thus far */
int nmask;			/* number of mask segments */
int nreg;			/* number of regions in this set of rows */
int rid;			/* first valid region for current pixel */
int x, y;			/* current row and column */
int rlen;			/* length of temp region buf */
int *rbuf;			/* temp region flags */
int *rptr;			/* pointer into region buffer */

void incnmask(void)
{
  int omax;
  nmask++;
  if( nmask >= maxmask ){
    omax = maxmask;
    maxmask += MASKINC;
    masks = (FilterMask)realloc(masks, maxmask*sizeof(FilterMaskRec));
    memset(masks+omax, 0, (maxmask-omax)*sizeof(FilterMaskRec));
  }
}

FilterMask
IMFILTRTN(int txmin, int txmax, int tymin, int tymax, int tblock, int *got)
{
  int i, j, k, l;
  int get;
  int fieldonly;
  int maxshapes;
  GFilt g;
  Scan scan, tscan;

  /* allocate space for the globals */
  g = (GFilt)calloc(1, sizeof(GFiltRec));
  /* see if we have only the field shape */
  fieldonly = (NSHAPE==1) && strstr(FILTSTR, "field");
  /* allocate region records */
  maxshapes = NSHAPE+1;
  g->shapes = (Shape)calloc(maxshapes, sizeof(ShapeRec));
  /* make sure we start at 1 */
  g->block= max(1,tblock);
  g->xmin = max(1,txmin); 
  g->xmax = txmax;
  g->ymin = max(1,tymin);
  g->ymax = tymax;
  /* adjust min and max for block factor */
  g->xmin = (g->xmin+(g->block-1))/g->block;
  g->ymin = (g->ymin+(g->block-1))/g->block;
  g->xmax = (g->xmax+(g->block-1))/g->block;
  g->ymax = (g->ymax+(g->block-1))/g->block;
  /* allocate a temp region buffer */
  rlen = g->xmax - g->xmin + 1;
  rbuf = (int *)calloc(rlen+1, sizeof(int));
  /* allocate an array of masks, which will be written to caller */
  maxmask = MASKINC;
  masks = (FilterMask)calloc(maxmask, sizeof(FilterMaskRec));
  /* seed the first region mask value */
  nmask = 0;
  masks[nmask].region = 0;
  /* keep track of how many hits we had for this set of rows */
  nreg = 0;
  /* allocate a buffer for valid y row flags */
  g->ybuf = (char *)calloc(g->ymax+1, sizeof(char));
  /* initialize ybuf */
  FINIT;
  /* process all valid rows */
  for(i=1, y=g->ymin; y<=g->ymax; i++, y++){
    if( fieldonly ){
      /* inc the mask count, (extend mask array, if necessary) */
      masks[nmask].region = 1;
      masks[nmask].y = i;
      masks[nmask].xstart = g->xmin;
      masks[nmask].xstop = g->xmax;
      incnmask();
      continue;
    }
    if( g->ybuf[y] ){
      /* to start this line, we make a seed mask with no region */
      if( masks[nmask].region ){
	/* inc the mask count, (extend mask array, if necessary) */
	incnmask();
	masks[nmask].region = 0;
      }
      /* process each pixel in this row */
      for(j=1, x=g->xmin, rptr=&rbuf[1]; x<=g->xmax; j++, x++){
	/* get filter result, which is the region id or 0 */
	g->rid = 0;
	if( FILTER ){
	  /* never change a region id to a -1 */
	  if( *rptr == 0 ){
	    nreg++;
	    *rptr = g->rid ? g->rid : -1;
	  }
	  /* but always overwrite a -1 */
	  else if( (*rptr == -1) && (g->rid >0) ){
	    *rptr = g->rid;
	  }
	}
	/* bump pointer */
	rptr++;
      }
    }
    /* if we have processed a rows, make up the segments */
    if( nreg ){
      for(k=1; k<=rlen; k++){
	if( rbuf[k] != masks[nmask].region ){
	  /* if previous was non-zero region, finish it and bump to next */
	  if( masks[nmask].region ){
	    masks[nmask].xstop = k - 1;
	    /* inc the mask count, (extend mas array, if necessary) */
	    incnmask();
	  }
	  masks[nmask].y = y;
	  masks[nmask].region = rbuf[k];
	  masks[nmask].xstart = k;
	}
      }
      /* finish last non-zero segment, inc number of mask segs */
      if( masks[nmask].region ){
	masks[nmask].xstop = g->xmax;
	/* inc the mask count, (extend mas array, if necessary) */
	incnmask();
      }
      /* reset counters for next set of rows */
      (void)memset(rbuf, 0, (rlen+1)*sizeof(int));
      rptr = rbuf;
      nreg = 0;
    }
  }
  /* free polygon records */
  for(i=0; i<maxshapes; i++){
    if( g->shapes[i].scanlist ){
      for(j=0; j<g->ymax; j++){
	if( g->shapes[i].scanlist[j] ){
	  for(scan=g->shapes[i].scanlist[j]; scan; ){
	    tscan = scan->next;
	    free(scan);
	    scan = tscan;
	  }
	}
      }
      free(g->shapes[i].scanlist);
    }
  }
  /* free globals */
  if( g->shapes ) free(g->shapes);
  if( g->ybuf ) free(g->ybuf);
  if( g ) free(g);
  /* free buffers */
  if( rbuf) free(rbuf);
  /* return mask info */
  *got = nmask;
  return masks;
}


#ifdef FILTER_MAIN
int main(int argc, char **argv)
{
  int i;
  int get;
  int got;
  int txmin, txmax, tymin, tymax, tblock;
  char tbuf[SZ_LINE];

  /* process requests for region information for sections of the image */
#ifdef TEST
  while( fgets(tbuf, SZ_LINE, stdin) ){
#else
  while( (read(0, &get, sizeof(int)) >0) && (read(0, tbuf, get)==get) ){
#endif
    if(sscanf(tbuf, "%d %d %d %d %d",
	      &txmin, &txmax, &tymin, &tymax, &tblock)!=5){
      break;
    }
    masks = IMFILTRTN(txmin, txmax, tymin, tymax, tblock, &got);
#ifdef TEST
    /* display segments for debugging */
    fprintf(stdout, "nmask=%d\n", nmask);
    for(i=0; i<nmask; i++){
      fprintf(stdout, "region: %d\tx: (%d,%d)\ty: %d\n",
	      masks[i].region, masks[i].xstart, masks[i].xstop, masks[i].y);
    }
    fflush(stdout);
#else
    /* calculate size of data we will write */
    got =  got * sizeof(FilterMaskRec);
    write(1, &got, 4);
    write(1, masks, got);
#endif
    /* free mask records */
    if( masks ) free(masks);
  }
#ifndef TEST
  unlink(argv[0]);
#endif
}
#endif
