#ifndef __annulus_h__
#define __annulus_h__

#include "basecircle.h"

class Annulus : public BaseCircle {
 private:
  void sortRadii();

public:
  Annulus(Frame* p, const Vector& ctr, double r,
	  const char* clr, const char* f, const char* t, unsigned short prop);

  Annulus(Frame* p, const Vector& ctr, 
	  double start, double stop, int num,
	  const char* clr, const char* f, const char* t, unsigned short prop);

  Annulus(Frame* p, const Vector& ctr, double* r, int n,
	  const char* clr, const char* f, const char* t, unsigned short prop);

  void updateBBox();
  void edit(const Vector&, int);
  void editEnd();

  void setRadii(double, double, int);
  void setRadii(const double*, int);
  const double* getRadii() {return radii;}
  int addRadii(const Vector&);
  void deleteRadii(int h);

  void list(ostream&, int, int, const char*);
  void listCiao(ostream&, int, int, const char*);
  void listFtools(ostream&, int, int, const char*);
  void listSAOimage(ostream&, const char*);
  void listPros(ostream&, int, int, const char*);
};

#endif
