#ifndef __baseellipse_h__
#define __baseellipse_h__

#include "basemarker.h"

class BaseEllipse : public BaseMarker {
protected:
  Vector* radii;
  double angle;
  Matrix flip;            // non iis needs a flip in Y

  void calcPoints(double);
  virtual void updateHandles() {}

public:
  BaseEllipse(Frame* p, const Vector& ctr, double a, 
	      const char* clr, const char* f, const char* t, 
	      unsigned short prop);
  virtual ~BaseEllipse();

  void updateCoords(Matrix&);
  virtual void edit(const Vector&, int) =0;
  virtual void endEnd() {}
  void rotate(const Vector&, int);
  int isIn(const Vector&);

  double getAngle() {return angle;}
  void setAngle(double);

  virtual void list(ostream&, int, int, const char*) =0;
  virtual void listCiao(ostream&, int, int, const char*) {}
  virtual void listFtools(ostream&, int, int, const char*) {}
  virtual void listSAOimage(ostream&, const char*) =0;
  virtual void listPros(ostream&, int, int, const char*) {}
};

#endif


