#ifndef __basemarker_h__
#define __basemarker_h__

#include <iostream.h>
#include <strstream.h>
#include <tk.h>

#include "marker.h"

#define MAXANNULI 512

class BaseMarker : public Marker {
protected:
  int segments;
  int annuli;
  Vector** vertices;

protected:
  virtual void updateHandles() {}
  virtual void calcPoints(double) {}

private:
  void render(Drawable drawable, const Matrix& matrix, GC, double);
  void newVertices();
  void deleteVertices();

public:
  BaseMarker(Frame*, const Vector&, int, const char*,  const char*, 
	       const char*, unsigned short);

  virtual void updateBBox();
  virtual void updateCoords(Matrix&) =0;
  virtual void draw();          // updates bbox and renders to pixmap
  virtual void drawXOR();
  virtual void drawMagnifier(const Matrix&);
  virtual void ps(int);
  int getAnnuliCount() {return annuli;}

  virtual void list(ostream&, int, int, const char*) =0;
  virtual void listCiao(ostream&, int, int, const char*) =0;
  virtual void listFtools(ostream&, int, int, const char*) =0;
  virtual void listSAOimage(ostream&, const char*) =0;
  virtual void listPros(ostream&, int, int, const char*) =0;
};

#endif
