#ifndef __ellipseannulus_h__
#define __ellipseannulus_h__

#include "baseellipse.h"

class EllipseAnnulus : public BaseEllipse {
private:
  void updateHandles();
  void sortRadii();

public:
  EllipseAnnulus(Frame* p, const Vector& ctr, const Vector& r, double a, 
		 const char* clr,  const char* f, const char* t, 
		 unsigned short prop);

  EllipseAnnulus(Frame* p, const Vector& ctr, 
		 const Vector& inner, const Vector& outer, int, double a, 
		 const char* clr,  const char* f, const char* t, 
		 unsigned short prop);

  EllipseAnnulus(Frame* p, const Vector& ctr, double a, int an, Vector* r,
		 const char* clr,  const char* f, const char* t, 
		 unsigned short prop);

  void edit(const Vector&, int);
  void editEnd();

  const Vector* getRadii() {return radii;}
  void setRadii(const Vector&, const Vector&, int);
  void setRadii(const Vector*, int);
  int addRadii(const Vector&);
  void deleteRadii(int h);

  void list(ostream&, int, int, const char*);
  void listSAOimage(ostream&, const char*);
};

#endif


